#include "config.h"
#ifdef NDB
#include <NdbApi.hpp>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <vector>
#include <iostream>
#include <sstream>
#include <fstream>
#include <time.h>
#include <float.h>
#include <limits>
#include "base64.h"


#include <time.h>
#include <sys/time.h>
#include <string.h>
#include <getopt.h>


#include "errorhandling.h"
#include "util.h"

#define uint2korr(A)    (uint16) (((uint16) ((unsigned char) (A)[0])) +\
                                  ((uint16) ((unsigned char) (A)[1]) << 8)) 

char  g_database[256];
char  * ndbconnectstring=0;
char  mysqlhost[256];
char  mysqluser[256];
char  mysqlpass[256];
char  * mysqlquery=0;
char  mysqlsocket[256];

bool verbose = false;
int execForceValue = 0;
int apiNodeId = 0;


int g_max_queries = 10000;
int g_max_threads = 1;
int g_port =3306;
int g_batch=1;
int g_runtime=0;
int g_multi=0;
int g_less_than_ms=5;
bool g_write_file=false;
const int64 sec2usec=1000*1000;
const char * thisFile = __FILE__;

char g_testname[256];



using namespace std;

// arguments to main()

void
print_help()
{
  printf("Usage: bencher  \n"
#ifdef NDB
	 " -c --ndb-connectstring=connectstring (not set) \n"	 
#endif
	 " -h --mysqlhost=mysql hostname (localhost)\n"	 
	 " -u --mysqluser=mysql username (root)\n"	 
	 " -p --mysqlpassword=mysql password (\"\")\n"	 
	 " -s --mysqlsocket=mysql socket (/tmp/mysql.sock)\n"
	 " -q --mysqlquery=query  (not set)\n" 	 
	 " -P --mysqlport=mysql port  (3306)\n" 	 
	 " -d --database=databaseName  (test)\n" 
	 " -t --threads=N  (1)\n" 
	 " -l --loops=N (10000)\n"
	 " -b --batch=N (1)\n"
	 " -r --runtime=N (specfies how many seconds the test should run, cannot be used with --loops)\n"
	 " -o --output=<testname>  (writes stats to two files for gnuplot)\n"
	 " -T --querytime-threshold=N  (5)\n" 
#ifdef NDB
	 " -m --ndbmulticonnect\n"
#endif
	 );
  exit(1);
}



int option(int argc, char** argv)
{
  int c;
  
  while (1)
    {
      static struct option long_options[] =
	{
	  {"help", 0, 0, '?'},
	  {"database", 1, 0, 'd'},
#ifdef NDB
	  {"ndb-connectstring", 1, 0, 'c'},
#endif
	  {"mysqlhost", 1, 0, 'h'},
	  {"mysqluser", 1, 0, 'u'},
	  {"mysqlpassword", 1, 0, 'p'},
	  {"mysqlsocket", 1, 0, 's'},
	  {"mysqlport", 1, 0, 'P'},
	  {"mysqlquery", 1, 0, 'q'},
	  {"threads", 1, 0, 't'},
	  {"loops", 1, 0, 'l'},
	  {"output", 1, 0, 'l'},
	  {"querytime-threshold", 1, 0, 'T'},
	  {"runtime", 1, 0, 'r'},	  
	  {"batch", 1, 0, 'b'},
#ifdef NDB
	  {"ndbmulticonnect", 0, 0, 'm'},
#endif
	  {0, 0, 0, 0}
	};
      /* getopt_long stores the option index here.   */
      int option_index = 0;

      c = getopt_long (argc, argv, "?ad:c:t:l:P:p:u:h:s:q:T:r:w:o:m",
		       long_options, &option_index);

      /* Detect the end of the options.   */
      if (c == -1)
	{
	  break;
	}


      switch (c)
	{
	case 0:
	  /* If this option set a flag, do nothing else now.   */
	  if (long_options[option_index].flag != 0)
	    break;
	  printf ("option %s", long_options[option_index].name);
	  if (optarg)
	    printf (" with arg %s", optarg);
	  printf ("\n");
	  
	  break;
	case 'c':
	  ndbconnectstring=(char*)malloc(256* sizeof(char*));
	  memset( ndbconnectstring,0,255);
	  strcpy(ndbconnectstring,optarg);
	  break;
	case 'q':
	  mysqlquery=(char*)malloc(strlen(optarg)+1);
	  memset(mysqlquery,0,sizeof(mysqlquery));
	  strcpy(mysqlquery,optarg);
	  break;
	case 'h':
	  memset(mysqlhost,0,255);
	  strcpy(mysqlhost,optarg);
	  break;
	case 'p':
	  memset(mysqlpass,0,255);
	  strcpy(mysqlpass,optarg);
	  break;
	case 'u':
	  memset(mysqluser,0,255);
	  strcpy(mysqluser,optarg);
	  break;
	case 's':
	  memset(mysqlsocket,0,255);
	  strcpy(mysqlsocket,optarg);
	  break;
	case 'P':
	  g_port=atoi(optarg);
	  break;
	case 'l':
	  g_max_queries=atoi(optarg);
	  break;
	case 'b':
	  g_batch=atoi(optarg);
	  break;
	case 'r':
	  g_runtime=atoi(optarg);
	  break;
	case 'm':
	  g_multi=1;
	  break;
	case 't':
	  g_max_threads = atoi(optarg);
	  break;
	case 'T':
	  g_less_than_ms= atoi(optarg);
	  break;	  
	case 'd':
	  memset(g_database,0,255);
	  strcpy(g_database,optarg);
	  break;
	case 'o':
	  g_write_file=true;
	  memset(g_testname,0,255);
	  strcpy(g_testname,optarg);
	  break;
	case '?':
	  {
	    print_help();
	    exit(-1);
	    break;
	  }
	default:
	  printf("Wrong options given. Try '-?' for help\n");
	  exit(-1);
	  break;
	}
    }
  return 0;  
  
}




typedef struct  my_threadData_t {
    my_threadData_t() :
#ifdef NDB 			
			ndb(0), 
#endif
			threadid(-1),
			numberOrRowsRetrieved(0), 
			startTimeMicrosec(0), 
			stopTimeMicrosec(0), 
			aggregateTime(0),
			tmax(0), 
			tmin(1000000), 
			less(0),
			exec_count(0),
			running(true)
	{
	}
    
#ifdef NDB 			
  Ndb * ndb;
#endif
  int threadid;
  int numberOrRowsRetrieved;
  int64 startTimeMicrosec;
  int64 stopTimeMicrosec;
  int64 startTimeMicrosecTrx;
  int64 stopTimeMicrosecTrx;
  int64 aggregateTime;
  int64 tmax;
  int64 tmin;
  int64 less;
  int64 exec_count;
  int64 t_sec_avg[86400];
  int64 * t_responsetime;
  bool running; 
}threadData_t;


// macro and data to help strncasecmp look for an argument prefix
int argPrefixLen;
#define strncasecmpARGPREFIX(arg) (arg), (argPrefixLen = strlen(arg))






const int64 MAX_INT64 = 9223372036854775807LL;
const int64 MIN_INT64 = -9223372036854775807LL; 
   // number of bytes for a date field



int64 startOfProgramMicrosec;
int64 startOfThreadsMicrosec;



    
 // @return 0 when successful; non-0 otherwise.
 // exits for database problem
#ifdef NDB
void *
thread_runner_ndb (void * t)
{
  threadData_t * ctx = (threadData_t *)t;
  
  Ndb * myNdb = ctx->ndb;
  bool stopTest=false;
  

  int delta=0;
  ctx->startTimeMicrosec=JULIANTIMESTAMP();	 
 

  NdbDictionary::Dictionary *dict=myNdb->getDictionary();
  long long int start=0;
  int k=0;
  int exec_time_secs=0;
  int exec_time=0;  
  int elapsed_time=0;
  int i=0;
  //  for(int i=0;i<g_max_queries;i++)
  while(true)
  {
    
    if(i==g_max_queries && !g_runtime)
      break;
    
  retry:      
      ctx->startTimeMicrosecTrx=JULIANTIMESTAMP();	 
      start=ctx->startTimeMicrosecTrx;

      NdbTransaction * trans = myNdb->startTransaction();
      for (int j=0; j<g_batch; j++)
	{
	  
	  

	  
	}
      if(trans->execute(NdbTransaction::Commit, 
			NdbOperation::AbortOnError, 1) < 0)
	{

	  NdbError err = trans->getNdbError();
	  printf("err msg=%s\n", err.message);  
	  if( err.status == NdbError::PermanentError)
	    {
	      if (err.code != 626) 
		{

		  stopTest=true;
		  ctx->stopTimeMicrosecTrx=JULIANTIMESTAMP();
		  trans->close();
		  trans=NULL;
		  break;
		}
	    }
	  if( err.status == NdbError::TemporaryError)
	    {
	      trans->close();
	      trans=NULL;
	      milliSleep(10);
	      goto retry;
	    }
	}    

      trans->close(); 

      /*
       * Below is for statistics collection
       */

      ctx->stopTimeMicrosecTrx=JULIANTIMESTAMP();
      delta = (ctx->stopTimeMicrosecTrx - ctx->startTimeMicrosecTrx);
      /*ctx->tTime[k]=delta;
      k++;
      if(k==100000)
	k=0;*/     
      ctx->aggregateTime+=delta;
      if(delta < g_less_than_ms*1000)
	ctx->less++;
      if(ctx->tmax < delta)
	ctx->tmax=delta;
      if(ctx->tmin > delta)
	ctx->tmin=delta;
      elapsed_time+=delta;
      exec_time+=delta;    
      if(elapsed_time>5000*1000)
	{
	  printf("Thread %d - %llu tps (average tps measured after %llu secs)\n",		  ctx->threadid, i/(ctx->aggregateTime/1000000),
		 ctx->aggregateTime/1000000);
	  elapsed_time=0;
	}
      ctx->tmin=delta;
      
      if(exec_time>1000*1000)
	{
	  if(i>0)
	    ctx->t_sec_avg[exec_time_secs]=(int64)i/(ctx->aggregateTime/1000000);
	else
	  ctx->t_sec_avg[exec_time_secs]=0;
	  
	  ctx->t_responsetime[exec_time_secs]=delta;
	  exec_time_secs++;
	  exec_time=0;
	}
      
    if(elapsed_time>5000*1000)
      {
	printf("Thread %d - %llu tps (average tps measured after %llu secs)\n",		  ctx->threadid, i/(ctx->aggregateTime/1000000),
	       ctx->aggregateTime/1000000);
	elapsed_time=0;
      }

    if(g_runtime)
      if(exec_time_secs>g_runtime)
	{	  
	  ctx->exec_count=i;
	  break;
	}
    
    i++;
  }
  
  ctx->stopTimeMicrosec=JULIANTIMESTAMP();	 
  return 0;    
}
#endif


 // @return 0 when successful; non-0 otherwise.
 // exits for database problem
void *
thread_runner_mysql (void * t)
{
  threadData_t * ctx = (threadData_t *)t;
  int exec_time_secs=0;
  int exec_time=0;  
  int exec_time_100ms=0;
  int exec_time_ms=0;  
  
  int exec_count_100ms=0;
  bool stopTest=false;
  int delta=0;
  ctx->startTimeMicrosec=JULIANTIMESTAMP();	 
  MYSQL mysql;

  mysql_init(&mysql);

 
  if(!mysql_real_connect(&mysql, 
			 mysqlhost,
			 mysqluser,
			 mysqlpass,
			 g_database,
			 g_port, 
			 mysqlsocket,
			 CLIENT_MULTI_STATEMENTS))
    {
      
      printf("%s\n", mysql_error(&mysql));
      stopTest=true;
      exit(0);
    }
  bool no_cmdline_query=false;

  char * mysqlquery2=0;
  char * query=0;
  if(!mysqlquery)
    {      
      mysqlquery2=(char*)malloc(2048);
      no_cmdline_query=true;
    }
    
  int elapsed_time=0;
  int k=0;
  int i=0;
  char data[512];
  
  memset(data, 'a', sizeof(data));
  
  while(true)
    {
      
    retry:
      if(i==g_max_queries && !g_runtime)
	break;
      
      ctx->startTimeMicrosecTrx=JULIANTIMESTAMP();	 
      
      if(no_cmdline_query)
	{
	  memset(mysqlquery2,0,sizeof(mysqlquery2));
	  /*
	   * YOU SQL QUERY SHOULD BE COPIED INTO mysqlquery . E.g using sprintf:
	   */
	  /*
	    sprintf(mysqlquery2, "<your query goes here>", <params here>);   
	   */
	  query=mysqlquery2;
	}
      else
	{
	  query=mysqlquery;
	}
      if(!mysql_real_query( &mysql, query, strlen(query) ))
	{
	  int status=0;
	  MYSQL_RES * result;
	  /* process each statement result */
	  do {
	    /* did current statement return data? */
	    result = mysql_store_result(&mysql);
	    if (result)
	      {
		//  printf("%lld rows affected  id=%i\n",
		//   mysql_affected_rows(&mysql),i);
		/* yes; process rows and free the result set */
		mysql_free_result(result);
	      }
	    else          /* no result set or error */
	      {
		if (mysql_field_count(&mysql) == 0)
		  {
		    ///    printf("%lld rows affected  id=%i\n",
		    //   mysql_affected_rows(&mysql),i);
		  }
		else  /* some error occurred */
		  {
		    printf("Could not retrieve result set\n");
		    break;
		  }
	      }
	    /* more results? -1 = no, >0 = error, 0 = yes (keep looping) */
	    if ((status = mysql_next_result(&mysql)) > 0)
	      printf("Could not execute statement\n");
	  } while (status == 0);
	}       
      else // failed
	{
	  int errno=mysql_errno(&mysql);
	  ctx->stopTimeMicrosecTrx=JULIANTIMESTAMP();
	  printf("%s (%d) - Query failed - problematic query: %s\n",
		 mysql_error(&mysql),
		 errno, 
		 query);
	  if(errno == 1297)
	    {
	      /*temporary error - retry*/
	      printf("Thread %d - retrying transaction\n", ctx->threadid);
	      usleep(20*1000);
	      goto retry;
	    }

	  return 0;	
	}
      
	
      /*
       * Below is for statistics collection - no queries after this line
       */
      ctx->stopTimeMicrosecTrx=JULIANTIMESTAMP();
      delta = (ctx->stopTimeMicrosecTrx - ctx->startTimeMicrosecTrx);
      /*ctx->tTime[k]=delta;
      k++;
      if(k==100000)
	k=0;
*/
      ctx->aggregateTime+=delta;
      if(delta < g_less_than_ms*1000)
	ctx->less++;
      if(ctx->tmax < delta)
	ctx->tmax=delta;
      if(ctx->tmin > delta)
	ctx->tmin=delta;
      exec_time+=delta;    
      exec_time_ms+=delta;    
      elapsed_time+=delta;
	exec_count_100ms++;

	if (exec_time_ms>100*1000)
	{
	  ctx->t_responsetime[exec_time_100ms]=delta;
	  exec_time_100ms++;
	  exec_count_100ms=0;;
	  exec_time_ms=0;
	}
      
	if(exec_time>1000*1000)
	{
	  ctx->t_sec_avg[exec_time_secs]=(int64)i/(ctx->aggregateTime/1000000);
	  exec_time_secs++;
	  exec_time=0;
	}
      
      if(elapsed_time>5000*1000)
	{
	  printf("Thread %d - %llu tps (average tps measured after %llu secs)\n",		  ctx->threadid, i/(ctx->aggregateTime/1000000),
		 ctx->aggregateTime/1000000);
	  elapsed_time=0;
	}

      if(g_runtime)
	if(exec_time_secs>g_runtime)
	  {	  
	    ctx->exec_count=i;
	  break;
	  }
      i++;
    } 
  mysql_close(&mysql);  
  ctx->stopTimeMicrosec=JULIANTIMESTAMP();	 
  return 0;    
  
}



int 
main (int argc, char ** argv)
{
  startOfProgramMicrosec = JULIANTIMESTAMP();

  strcpy(g_database,"test");
  strcpy(mysqlhost, "localhost");
  strcpy(mysqluser, "root");
  strcpy(mysqlpass, "");
  strcpy(mysqlsocket, "/tmp/mysql.sock");

  option(argc,argv);

  /**
   * This should be in shared mem area of Apache
   * Once for each apache instance, not for each child
   */
#ifdef NDB
  ndb_init();
  /**************************************************************
   * Connect to ndb cluster                                     *
   **************************************************************/
  
  vector<Ndb_cluster_connection *> myConn;
  myConn.resize (g_max_threads);
#endif
  
  vector<pthread_t> threads;
  threads.resize (g_max_threads);
  
  vector<threadData_t> tdata;
  tdata.resize (g_max_threads);
#ifdef NDB
    vector<Ndb *> myNdb;
    myNdb.resize (g_max_threads);
    if(g_multi  && ndbconnectstring!=0)
      printf("Going to make %d connections to cluster\n",g_max_threads);
    if(!g_multi  && ndbconnectstring!=0)
      printf("Going to make 1 connection to cluster\n");
    if(!g_multi && ndbconnectstring!=0)
      {	
	myConn[0] = new Ndb_cluster_connection(ndbconnectstring);
	if (myConn[0]->connect(4, 5, 1) < 0)
	  {
	    printf( "Unable to connect to cluster within 30 secs.\n");
	    exit(-1);
	  }
	// Optionally connect and wait for the storage nodes (ndbd's)
	if (myConn[0]->wait_until_ready(30,0) < 0)
	  {
	    printf( "Cluster was not ready within 30 secs.\n");
	    exit(-1);
	  }
	printf("Connected to cluster\n");
      }
#endif
    for(int i=0; i<g_max_threads ;i++) 
      {
#ifdef NDB
	if(ndbconnectstring!=0)
	  {
	    if(g_multi)
	      {
		myConn[i] = new Ndb_cluster_connection(ndbconnectstring);
		if (myConn[i]->connect(4, 5, 1) < 0)
		  {
		    printf( "Unable to connect to cluster within 30 secs.\n");
		    exit(-1);
		  }
		// Optionally connect and wait for the storage nodes (ndbd's)
		if (myConn[i]->wait_until_ready(30,0) < 0)
		  {
		    printf( "Cluster was not ready within 30 secs.\n");
		    exit(-1);
		  }
		myNdb[i] = new Ndb(myConn[i], g_database);
		printf("Connection %d (of %d connections) connected to cluster\n", i, g_max_threads);
	      }
	    else
	      myNdb[i] = new Ndb(myConn[0], g_database);
	    if (myNdb[i]->init(1024) == -1) { // Set max 1024  parallel transactions
	      APIERROR(myNdb[i]->getNdbError());
	      exit(-1);
	    }
	  }
#endif 
    
	threadData_t & thistdata = tdata[i];
#ifdef NDB
        thistdata.ndb=myNdb[i];
#endif
	thistdata.threadid=i;
	thistdata.numberOrRowsRetrieved=0;
	thistdata.startTimeMicrosec = MAX_INT64;
	thistdata.stopTimeMicrosec = MIN_INT64;
	for(int k=0;k<86400;k++)
	  {
	    thistdata.t_sec_avg[k]=0LL;	
	  }
	thistdata.t_responsetime=(int64*)malloc(sizeof(int64)*864000);
	memset(thistdata.t_responsetime,0, sizeof(int64)*864000);
      }
    
    printf("\n------- Starting Benchmark ----------\n");
    for(int i=0; i<g_max_threads;i++) 
      {
#ifdef NDB
	if(ndbconnectstring==0)
#endif
	  pthread_create(&threads[i], NULL, thread_runner_mysql, &tdata[i]);	
#ifdef NDB
	else
	  pthread_create(&threads[i], NULL, thread_runner_ndb, &tdata[i]);
#endif	
      }      
    
    startOfThreadsMicrosec=JULIANTIMESTAMP();
    for (int i = 0; i < g_max_threads; i++)
    {
      pthread_join(threads[i], NULL);
    }
    int totalThreadsMicrosec=JULIANTIMESTAMP()-startOfThreadsMicrosec;
    int total_time=(int)(totalThreadsMicrosec/1000000LL);
    
    int64 totTime=0;    
    double totQps=0;
    printf("\n------- Benchmark Finished ----------\n");
    
    for (int i = 0; i < g_max_threads; ++i) 
      {
	printf( "Thread  %d -  max: %llu us, min %llu us, "
		"less than %d ms: %llu of %llu,", i ,
		tdata[i].tmax,
		tdata[i].tmin ,
		g_less_than_ms,
		tdata[i].less,
		g_runtime ? tdata[i].exec_count : g_max_queries);
	if(g_runtime)
	  printf( " avg: %llu us, ",(tdata[i].aggregateTime/tdata[i].exec_count));     
	else
	  printf( " avg: %llu us, ",(tdata[i].aggregateTime/g_max_queries));     
	printf( "total time: %llu ms,", 
	  (tdata[i].stopTimeMicrosec - tdata[i].startTimeMicrosec)/1000);
	totTime+=(tdata[i].stopTimeMicrosec - tdata[i].startTimeMicrosec);
	if(g_runtime) 
	  {
          printf( " tps: %2.2f \n",(double)tdata[i].exec_count/(double)(((double)tdata[i].stopTimeMicrosec - (double)tdata[i].startTimeMicrosec)/(1000*1000)));
	  totQps+=(double)tdata[i].exec_count/(double)(((double)tdata[i].stopTimeMicrosec - (double)tdata[i].startTimeMicrosec)/(1000*1000));
	  }
	else 
	  {
         printf( " tps: %2.2f \n",(double)g_max_queries/(double)(((double)tdata[i].stopTimeMicrosec - (double)tdata[i].startTimeMicrosec)/(1000*1000)));
	  totQps+=(double)g_max_queries/(double)(((double)tdata[i].stopTimeMicrosec - (double)tdata[i].startTimeMicrosec)/(1000*1000));
	  }


      }
    printf( "\nTotal throughput = %2.2f tps\n", totQps);
    printf( "Average exec time per thread = %2.2f secs\n\n",
	    (double)totTime/(double)(1000*1000*g_max_threads));
    if(g_write_file)
     { 
	char fspath[128];
	char filename1[128];
	char filename2[128];
	char filename3[128];
	char fname1[128];
	char fname2[128];
	char fname3[128];
	strcpy(fspath,"./");
	sprintf(filename1,"%s/bencher_t%d_%s_tp.dat", fspath, g_max_threads, g_testname);
	sprintf(filename2,"%s/bencher_t%d_%s_rt.dat", fspath, g_max_threads, g_testname);
	sprintf(filename3,"%s/gnuplot_t%d_%s.script", fspath, g_max_threads, g_testname);
	sprintf(fname1,"bencher_t%d_%s_tp.dat", g_max_threads, g_testname);
	sprintf(fname2,"bencher_t%d_%s_rt.dat", g_max_threads, g_testname);
	sprintf(fname3,"gnuplot_t%d_%s.script", g_max_threads, g_testname);
	FILE *fp1, *fp2, *fp3;
	char line1[128];
	char line2[128];
	char line3[128];
	fp1 = fopen(filename1, "w");
	fp2 = fopen(filename2, "w");
	fp3 = fopen(filename3, "w");
	if(fp1==0)
	  {
	    printf("Could not open file\n");
	    exit(1);
	  }
	if(fp2==0)
	  {
	    printf("Could not open file\n");
	    exit(1);
	  }

	if(fp3==0)
	  {
	    printf("Could not open file\n");
	    exit(1);
	  }
	
	int runtime=0;    
	if(g_runtime)
	  runtime=g_runtime;
	else
	  runtime=total_time;    
	int64 aggregate_tp[runtime];
	int64 aggregate_rt[runtime*10];
	memset(aggregate_tp,0,runtime*sizeof(int64));
	memset(aggregate_rt,0,10*runtime*sizeof(int64));
	int64 min= MAX_INT64;
	int64 max= MIN_INT64;
	int64 avg_lat=0;
	int64 overall_max=MIN_INT64;
	
	for (int j=0;j<runtime;j++)
	  {
	    for (int i = 0; i < g_max_threads; i++) 
	      {       
		aggregate_tp[j]+=tdata[i].t_sec_avg[j];
	      }
	    sprintf(line1,"%d\t%llu\n", j,aggregate_tp[j]);
	    fputs(line1,fp1);
	  }
	
	for (int j=0;j<(runtime*10);j++)
	  {
	    for (int i = 0; i < g_max_threads; i++) 
	      {       
		aggregate_rt[j]+=tdata[i].t_responsetime[j];
		if(tdata[i].t_responsetime[j]>max && tdata[i].t_responsetime[j]>0)
		  max=tdata[i].t_responsetime[j];
		if(tdata[i].t_responsetime[j]<min && tdata[i].t_responsetime[j]>0)
		  min=tdata[i].t_responsetime[j];
	      }
	    avg_lat=aggregate_rt[j]/g_max_threads;
	    sprintf(line2,"%d\t%llu\t%llu\t%llu\n", j,
		    avg_lat,min,max);
	    fputs(line2,fp2);
	    if(max>overall_max)
	      overall_max=max;
	    min= MAX_INT64;
	    max= MIN_INT64;
	    
	  }
	fclose(fp1);
	fclose(fp2);

	float tmp_max_lat=(float)overall_max*1.2;
	float tmp_tot_qps=(float)totQps*1.2;
	
	fputs("set term png small\n",fp3);
	fputs("set data style lines\n",fp3);
	fputs("set grid\nset multiplot\n",fp3);
	fputs("set size 1,0.5\n",fp3);
	fputs("set origin 0,0.5\n",fp3);
	sprintf(line3,"set yrange [ 0 : %d ]\n", (int) (tmp_tot_qps));
	sprintf(line3,"set xrange [ 0 : %d ]\n", (int) (runtime-1));
	fputs(line3,fp3);
	sprintf(line3,"set title \"Test case: %s - throughput\"\n", g_testname);
	fputs(line3,fp3);
	fputs("set xlabel \"seconds\"\n",fp3);
	fputs("set ylabel \"tps\"\n",fp3);
	sprintf(line3,"plot \"%s\" using 1:($2) with lines title \"throughput\"\\\n", fname1);
	fputs(line3,fp3);
	fputs("\n\nset size 1,0.5\n",fp3);
	fputs("set origin 0,0\n",fp3);
	sprintf(line3,"set yrange [ 0.1 : %lld ]\n", (unsigned long long) (tmp_max_lat));
	fputs(line3,fp3);
	sprintf(line3,"set title \"Test case: %s - latency\"\n", g_testname);
	fputs(line3,fp3);
	fputs("set logscale y\n",fp3);
	fputs("set xlabel \"seconds\"\n",fp3);
	fputs("set ylabel \"latency (us)\"\n",fp3);

	sprintf(line3,"plot \"%s\" using ($1/10):2 with points title \"avg\"\\\n", fname2);
	fputs(line3,fp3);
	sprintf(line3,", \"%s\" using ($1/10):3 with points title \"min\"\\\n", fname2);
	fputs(line3,fp3);
	sprintf(line3,", \"%s\" using ($1/10):4 with points title \"max\"\\\n", fname2);
	fputs(line3,fp3);
	
	/*sprintf(line3,"plot \"%s\" using 1:($2) with points title \"avg\"\\\n", fname2);
	fputs(line3,fp3);
	sprintf(line3,", \"%s\" using 1:($3) with points title \"min\"\\\n", fname2);
	fputs(line3,fp3);
	sprintf(line3,", \"%s\" using 1:($4) with points title \"max\"\\\n", fname2);
	fputs(line3,fp3);
*/

	fclose(fp3);
	printf("Wrote '%s' and '%s'\n", filename1, filename2);
	printf("The '*_tp.dat' contains throughput data,"
	       "and '*_rt.dat' contains response time data\n");
	printf("Wrote '%s' to be used with gnuplot ( 'gnuplot %s > %s.png') \n",
	       filename3,filename3,g_testname);
      }

#ifdef NDB
    if(ndbconnectstring!=0)
      {
	for (int i = 0; i < g_max_threads; ++i) 
	  {
	    delete myNdb[i];
	  }
      }
#endif
    exit(0); 
}

    
